#include <stdio.h>
#include <curl/curl.h>

int main( int argc, char *argv[] )
{
    CURL *curl = NULL;
    CURLcode res;

    curl_global_init( CURL_GLOBAL_DEFAULT );

    curl = curl_easy_init(  );
    if ( curl == NULL ) {
        printf( "ERROR: curl_easy_init() failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_SSLCERT, "./test.pem" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting SSL cert file failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_KEYPASSWD, "test" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting SSL passphrase failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_SSLKEY, "./test-key.pem" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting SSL key file failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_CAINFO, "./test-ca.pem" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting SSL CA file failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_URL, "https://test.local" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting HTTPS URL failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_POST, 1L );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting HTTP POST failed.\n" );
        return -1;
    }

    res = curl_easy_setopt( curl, CURLOPT_POSTFIELDS, "test" );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Setting POST data failed.\n" );
        return -1;
    }

    // and so begins the memory leak...
    res = curl_easy_perform( curl );
    if ( res != CURLE_OK ) {
        printf( "ERROR: Sending POST failed.\n" );
        return -1;
    }

    curl_global_cleanup(  );

    return 0;
}
